MantisBT

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0000424Hall D OfflineGeneralpublic2014-12-02 16:522015-06-10 09:42
Reporterdavidl 
Assigned Todavidl 
PrioritynormalSeveritycrashReproducibilityhave not tried
StatusresolvedResolutionfixed 
PlatformOSOS Version
Summary0000424: Seg fault from mcsmear
DescriptionA seg. fault is reported when running mcsmear using conditions described in Tom's e-mail copied in the "Additional Information" section. In a subsequent e-mail, he notes that he's using Linux_CentOS6-x86_64-gcc4.4.6 and that files demonstrating the problem can be found here:

https://docs.google.com/a/umail.iu.edu/file/d/0B2d57qMzynA9ejQ5Q3I0TDNTelE/edit?usp=drive_web [^]
Additional InformationHi all,

I’m trying to generate some MC using the commissioning branch and simulation conditions. I’m generating some events using genr8 and running them through hdgeant using control.in_9101. When I try to run mcsmear on the output, I get a segfault after processing a couple hundred events. I see the same behavior if I generate events using bggen. I included a stack trace below. Does anyone have any advice for fixing this?

Tom Boettcher

Program received signal SIGSEGV, Segmentation fault.
[Switching to Thread 0x7ffff15f2700 (LWP 10822)]
0x0000000000bec50e in sgetn (this=0x7fffec5e9190, s="")
   at /usr/lib/gcc/x86_64-redhat-linux/4.4.6/../../../../include/c++/4.4.6/streambuf:335
335 { return this->xsgetn(__s, __n); }
Missing separate debuginfos, use: debuginfo-install bzip2-libs-1.0.5-7.el6_0.x86_64 cyrus-sasl-lib-2.1.23-13.el6_3.1.x86_64 freetype-2.3.11-14.el6_3.1.x86_64 glibc-2.12-1.80.el6_3.7.x86_64 keyutils-libs-1.4-4.el6.x86_64 krb5-libs-1.9-33.el6_3.3.x86_64 libcom_err-1.41.12-12.el6.x86_64 libcurl-7.19.7-26.el6_2.4.x86_64 libgcc-4.4.6-4.el6.x86_64 libidn-1.18-2.el6.x86_64 libselinux-2.0.94-5.3.el6.x86_64 libssh2-1.2.2-11.el6_3.x86_64 libstdc++-4.4.6-4.el6.x86_64 nspr-4.9.2-0.el6_3.1.x86_64 nss-3.13.6-2.el6_3.x86_64 nss-softokn-freebl-3.12.9-11.el6.x86_64 nss-util-3.13.6-1.el6_3.x86_64 openldap-2.4.23-26.el6_3.2.x86_64 openssl-1.0.1e-30.el6_5.2.x86_64 pcre-7.8-4.el6.x86_64 zlib-1.2.3-27.el6.x86_64
(gdb) where
#0 0x0000000000bec50e in sgetn (this=0x7fffec5e9190, s="")
   at /usr/lib/gcc/x86_64-redhat-linux/4.4.6/../../../../include/c++/4.4.6/streambuf:335
0000001 xstream::xdr::istream::operator>> (this=0x7fffec5e9190, s="") at external/xstream/src/xdr.cpp:133
0000002 0x00000000005bd5dd in hddm_s::BcalSiPMSpectrum::streamer (this=0x7fffec882290, istr=...)
   at /home/fs7/tboettch/HallD_Home/install/sim-recon/sim-recon-commissioning/Linux_CentOS6-x86_64-gcc4.4.6/include/HDDM/hddm_s.hpp:16529
0000003 0x00000000005bce25 in hddm_s::istream::sequencer (this=0x7fffec000d10, object=...)
   at /home/fs7/tboettch/HallD_Home/install/sim-recon/sim-recon-commissioning/Linux_CentOS6-x86_64-gcc4.4.6/include/HDDM/hddm_s.hpp:4961
0000004 0x00000000005e4ab1 in hddm_s::HDDM_ElementList<hddm_s::BcalSiPMSpectrum>::streamer (this=0x7fffec75a308, istr=...)
   at /home/fs7/tboettch/HallD_Home/install/sim-recon/sim-recon-commissioning/Linux_CentOS6-x86_64-gcc4.4.6/include/HDDM/hddm_s.hpp:428
0000005 0x00000000005bce25 in hddm_s::istream::sequencer (this=0x7fffec000d10, object=...)
   at /home/fs7/tboettch/HallD_Home/install/sim-recon/sim-recon-commissioning/Linux_CentOS6-x86_64-gcc4.4.6/include/HDDM/hddm_s.hpp:4961
0000006 0x00000000005bccaf in hddm_s::istream::operator>> (this=0x7fffec000d10, object=...)
   at /home/fs7/tboettch/HallD_Home/install/sim-recon/sim-recon-commissioning/Linux_CentOS6-x86_64-gcc4.4.6/include/HDDM/hddm_s.hpp:4951
0000007 0x00000000005bcec7 in hddm_s::istream::sequencer (this=0x7fffec000d10, object=<value optimized out>)
   at /home/fs7/tboettch/HallD_Home/install/sim-recon/sim-recon-commissioning/Linux_CentOS6-x86_64-gcc4.4.6/include/HDDM/hddm_s.hpp:4973
0000008 0x00000000005e5140 in hddm_s::HDDM_ElementList<hddm_s::BcalCell>::streamer (this=<value optimized out>, istr=...)
   at /home/fs7/tboettch/HallD_Home/install/sim-recon/sim-recon-commissioning/Linux_CentOS6-x86_64-gcc4.4.6/include/HDDM/hddm_s.hpp:428
0000009 0x00000000005bce25 in hddm_s::istream::sequencer (this=0x7fffec000d10, object=...)
   at /home/fs7/tboettch/HallD_Home/install/sim-recon/sim-recon-commissioning/Linux_CentOS6-x86_64-gcc4.4.6/include/HDDM/hddm_s.hpp:4961
0000010 0x00000000005bccaf in hddm_s::istream::operator>> (this=0x7fffec000d10, object=...)
   at /home/fs7/tboettch/HallD_Home/install/sim-recon/sim-recon-commissioning/Linux_CentOS6-x86_64-gcc4.4.6/include/HDDM/hddm_s.hpp:4951
0000011 0x00000000005bcec7 in hddm_s::istream::sequencer (this=0x7fffec000d10, object=<value optimized out>)
   at /home/fs7/tboettch/HallD_Home/install/sim-recon/sim-recon-commissioning/Linux_CentOS6-x86_64-gcc4.4.6/include/HDDM/hddm_s.hpp:4973
#12 0x00000000005bccaf in hddm_s::istream::operator>> (this=0x7fffec000d10, object=...)
   at /home/fs7/tboettch/HallD_Home/install/sim-recon/sim-recon-commissioning/Linux_CentOS6-x86_64-gcc4.4.6/include/HDDM/hddm_s.hpp:4951
0000013 0x00000000005bcec7 in hddm_s::istream::sequencer (this=0x7fffec000d10, object=<value optimized out>)
   at /home/fs7/tboettch/HallD_Home/install/sim-recon/sim-recon-commissioning/Linux_CentOS6-x86_64-gcc4.4.6/include/HDDM/hddm_s.hpp:4973
0000014 0x00000000005bccaf in hddm_s::istream::operator>> (this=0x7fffec000d10, object=...)
   at /home/fs7/tboettch/HallD_Home/install/sim-recon/sim-recon-commissioning/Linux_CentOS6-x86_64-gcc4.4.6/include/HDDM/hddm_s.hpp:4951
0000015 0x00000000005bcec7 in hddm_s::istream::sequencer (this=0x7fffec000d10, object=<value optimized out>)
   at /home/fs7/tboettch/HallD_Home/install/sim-recon/sim-recon-commissioning/Linux_CentOS6-x86_64-gcc4.4.6/include/HDDM/hddm_s.hpp:4973
0000016 0x00000000005dcb5f in hddm_s::HDDM_ElementList<hddm_s::PhysicsEvent>::streamer (this=<value optimized out>,
   istr=...)
---Type <return> to continue, or q <return> to quit---
   at /home/fs7/tboettch/HallD_Home/install/sim-recon/sim-recon-commissioning/Linux_CentOS6-x86_64-gcc4.4.6/include/HDDM/hddm_s.hpp:428
0000017 0x00000000005bce25 in hddm_s::istream::sequencer (this=0x7fffec000d10, object=...)
   at /home/fs7/tboettch/HallD_Home/install/sim-recon/sim-recon-commissioning/Linux_CentOS6-x86_64-gcc4.4.6/include/HDDM/hddm_s.hpp:4961
0000018 0x00000000005bccaf in hddm_s::istream::operator>> (this=0x7fffec000d10, object=...)
   at /home/fs7/tboettch/HallD_Home/install/sim-recon/sim-recon-commissioning/Linux_CentOS6-x86_64-gcc4.4.6/include/HDDM/hddm_s.hpp:4951
0000019 0x00000000005bcec7 in hddm_s::istream::sequencer (this=0x7fffec000d10, object=<value optimized out>)
   at /home/fs7/tboettch/HallD_Home/install/sim-recon/sim-recon-commissioning/Linux_CentOS6-x86_64-gcc4.4.6/include/HDDM/hddm_s.hpp:4973
0000020 0x00000000005bccaf in hddm_s::istream::operator>> (this=0x7fffec000d10, object=...)
   at /home/fs7/tboettch/HallD_Home/install/sim-recon/sim-recon-commissioning/Linux_CentOS6-x86_64-gcc4.4.6/include/HDDM/hddm_s.hpp:4951
0000021 0x0000000000bca557 in hddm_s::istream::operator>> (this=0x7fffec000d10, record=...)
   at .Linux_CentOS6-x86_64-gcc4.4.6/libraries/HDDM/hddm_s++.cpp:217
0000022 0x0000000000b9cdc8 in DEventSourceHDDM::GetEvent (this=0x7fffec000fa0, event=...)
   at libraries/HDDM/DEventSourceHDDM.cc:109
0000023 0x0000000000c2f992 in jana::JEventSource::GetEvent (this=0x7fffec000fa0, event=...) at src/JANA/JEventSource.cc:54
0000024 0x0000000000bf174b in jana::JApplication::ReadEvent (this=0x7fffffffce20, event=...)
   at src/JANA/JApplication.cc:655
0000025 0x0000000000bf15c1 in jana::JApplication::EventBufferThread (this=0x7fffffffce20) at src/JANA/JApplication.cc:600
0000026 0x0000000000bf12af in LaunchEventBufferThread (arg=0x7fffffffce20) at src/JANA/JApplication.cc:552
0000027 0x0000003d99807851 in start_thread () from /lib64/libpthread.so.0
0000028 0x0000003d98ce811d in clone () from /lib64/libc.so.6_______________________________________________
Halld-offline mailing list
Halld-offline@jlab.org
https://mailman.jlab.org/mailman/listinfo/halld-offline [^]
TagsNo tags attached.
Attached Files

- Relationships

-  Notes
(0000619)
davidl (administrator)
2014-12-03 15:44

I was able to find one issue that looked to be causing the initial crashes Tom was seeing. It was in the smear_bcal.cc file and a fix was checked in to the commissioning branch as revision .

I was still unable to cleanly run mcsmear as it started crashing in a different place. This seems to be deep in the xdr reader code where it is getting a length that is equivalent to all bits set to 1 (i.e. very large number). This occurred around event 93 when I ran the following:

> mcsmear hdgeant_POmega.hddm

The backtrace is copied below from running on Linux. I also observed crashes at the same place when running on Mac OS X. It is worth noting that I also observe a problem using hddm-xml. It prints out a bunch of garbage for the "vals" field of bcalSiPMSpectrum structure in the event. This may indicate a corrupted output from hdgeant for the BCAL SiPM data.

----------------------------------------------------------------------------
Program received signal SIGSEGV, Segmentation fault.
[Switching to Thread 0x7fa4424b7700 (LWP 25944)]
0x0000000000d21ede in sgetn (this=0x7fa43c0218c0, s="") at /usr/lib/gcc/x86_64-redhat-linux/4.4.6/../../../../include/c++/4.4.6/streambuf:335
335 { return this->xsgetn(__s, __n); }
(gdb) bt
#0 0x0000000000d21ede in sgetn (this=0x7fa43c0218c0, s="") at /usr/lib/gcc/x86_64-redhat-linux/4.4.6/../../../../include/c++/4.4.6/streambuf:335
0000001 xstream::xdr::istream::operator>> (this=0x7fa43c0218c0, s="") at external/xstream/src/xdr.cpp:133
0000002 0x00000000005b7e4d in hddm_s::BcalSiPMSpectrum::streamer (this=0x7fa43c1ef1f0, istr=...)
    at /w/halld-scifs1a/home/davidl/builds/sim-recon-commissioning/Linux_CentOS6-x86_64-clang3.2/include/HDDM/hddm_s.hpp:16529
0000003 0x00000000005b74a5 in hddm_s::istream::sequencer (this=0x7fa43c000d60, object=...)
    at /w/halld-scifs1a/home/davidl/builds/sim-recon-commissioning/Linux_CentOS6-x86_64-clang3.2/include/HDDM/hddm_s.hpp:4961
0000004 0x00000000005cb651 in hddm_s::HDDM_ElementList<hddm_s::BcalSiPMSpectrum>::streamer (this=0x7fa43c5362a8, istr=...)
    at /w/halld-scifs1a/home/davidl/builds/sim-recon-commissioning/Linux_CentOS6-x86_64-clang3.2/include/HDDM/hddm_s.hpp:428
0000005 0x00000000005b74a5 in hddm_s::istream::sequencer (this=0x7fa43c000d60, object=...)
    at /w/halld-scifs1a/home/davidl/builds/sim-recon-commissioning/Linux_CentOS6-x86_64-clang3.2/include/HDDM/hddm_s.hpp:4961
0000006 0x00000000005b774d in hddm_s::istream::operator>> (this=0x7fa43c000d60, object=...)
    at /w/halld-scifs1a/home/davidl/builds/sim-recon-commissioning/Linux_CentOS6-x86_64-clang3.2/include/HDDM/hddm_s.hpp:4951
0000007 0x00000000005b7547 in hddm_s::istream::sequencer (this=0x7fa43c000d60, object=<value optimized out>)
    at /w/halld-scifs1a/home/davidl/builds/sim-recon-commissioning/Linux_CentOS6-x86_64-clang3.2/include/HDDM/hddm_s.hpp:4973
0000008 0x00000000005d11e7 in hddm_s::HDDM_ElementList<hddm_s::BcalCell>::streamer (this=<value optimized out>, istr=<value optimized out>)
    at /w/halld-scifs1a/home/davidl/builds/sim-recon-commissioning/Linux_CentOS6-x86_64-clang3.2/include/HDDM/hddm_s.hpp:428
0000009 0x00000000005b74a5 in hddm_s::istream::sequencer (this=0x7fa43c000d60, object=...)
    at /w/halld-scifs1a/home/davidl/builds/sim-recon-commissioning/Linux_CentOS6-x86_64-clang3.2/include/HDDM/hddm_s.hpp:4961
0000010 0x00000000005b774d in hddm_s::istream::operator>> (this=0x7fa43c000d60, object=...)
    at /w/halld-scifs1a/home/davidl/builds/sim-recon-commissioning/Linux_CentOS6-x86_64-clang3.2/include/HDDM/hddm_s.hpp:4951
0000011 0x00000000005b7547 in hddm_s::istream::sequencer (this=0x7fa43c000d60, object=<value optimized out>)
    at /w/halld-scifs1a/home/davidl/builds/sim-recon-commissioning/Linux_CentOS6-x86_64-clang3.2/include/HDDM/hddm_s.hpp:4973
#12 0x00000000005b774d in hddm_s::istream::operator>> (this=0x7fa43c000d60, object=...)
    at /w/halld-scifs1a/home/davidl/builds/sim-recon-commissioning/Linux_CentOS6-x86_64-clang3.2/include/HDDM/hddm_s.hpp:4951
0000013 0x00000000005b7547 in hddm_s::istream::sequencer (this=0x7fa43c000d60, object=<value optimized out>)
    at /w/halld-scifs1a/home/davidl/builds/sim-recon-commissioning/Linux_CentOS6-x86_64-clang3.2/include/HDDM/hddm_s.hpp:4973
0000014 0x00000000005b774d in hddm_s::istream::operator>> (this=0x7fa43c000d60, object=...)
    at /w/halld-scifs1a/home/davidl/builds/sim-recon-commissioning/Linux_CentOS6-x86_64-clang3.2/include/HDDM/hddm_s.hpp:4951
0000015 0x00000000005b7547 in hddm_s::istream::sequencer (this=0x7fa43c000d60, object=<value optimized out>)
    at /w/halld-scifs1a/home/davidl/builds/sim-recon-commissioning/Linux_CentOS6-x86_64-clang3.2/include/HDDM/hddm_s.hpp:4973
0000016 0x00000000005c39bf in hddm_s::HDDM_ElementList<hddm_s::PhysicsEvent>::streamer (this=<value optimized out>, istr=...)
    at /w/halld-scifs1a/home/davidl/builds/sim-recon-commissioning/Linux_CentOS6-x86_64-clang3.2/include/HDDM/hddm_s.hpp:428
0000017 0x00000000005b74a5 in hddm_s::istream::sequencer (this=0x7fa43c000d60, object=...)
    at /w/halld-scifs1a/home/davidl/builds/sim-recon-commissioning/Linux_CentOS6-x86_64-clang3.2/include/HDDM/hddm_s.hpp:4961
0000018 0x00000000005b774d in hddm_s::istream::operator>> (this=0x7fa43c000d60, object=...)
    at /w/halld-scifs1a/home/davidl/builds/sim-recon-commissioning/Linux_CentOS6-x86_64-clang3.2/include/HDDM/hddm_s.hpp:4951
0000019 0x00000000005b7547 in hddm_s::istream::sequencer (this=0x7fa43c000d60, object=<value optimized out>)
    at /w/halld-scifs1a/home/davidl/builds/sim-recon-commissioning/Linux_CentOS6-x86_64-clang3.2/include/HDDM/hddm_s.hpp:4973
0000020 0x00000000005b774d in hddm_s::istream::operator>> (this=0x7fa43c000d60, object=...)
    at /w/halld-scifs1a/home/davidl/builds/sim-recon-commissioning/Linux_CentOS6-x86_64-clang3.2/include/HDDM/hddm_s.hpp:4951
0000021 0x0000000000cf3a35 in hddm_s::istream::operator>> (this=0x7fa43c000d60, record=...) at .Linux_CentOS6-x86_64-clang3.2/libraries/HDDM/hddm_s++.cpp:217
0000022 0x0000000000ca89c6 in DEventSourceHDDM::GetEvent (this=0x7fa43c000f70, event=...) at libraries/HDDM/DEventSourceHDDM.cc:109
0000023 0x0000000000d65576 in jana::JEventSource::GetEvent (this=0x7fa43c000f70, event=...) at src/JANA/JEventSource.cc:54
0000024 0x0000000000d2711b in jana::JApplication::ReadEvent (this=0x7fffe24bc6d0, event=...) at src/JANA/JApplication.cc:655
0000025 0x0000000000d26f91 in jana::JApplication::EventBufferThread (this=0x7fffe24bc6d0) at src/JANA/JApplication.cc:600
0000026 0x0000000000d26c7f in LaunchEventBufferThread (arg=0x7fffe24bc6d0) at src/JANA/JApplication.cc:552
0000027 0x00000033466077f1 in start_thread () from /lib64/libpthread.so.0
0000028 0x0000003345ee5ccd in clone () from /lib64/libc.so.6
(gdb)
(0000647)
davidl (administrator)
2015-06-10 09:42

This looks like it may have been fixed by Sean D. with revision 18034 on April 15, 2015. I've not heard recent reports of mcsmear crashes.

- Issue History
Date Modified Username Field Change
2014-12-02 16:52 davidl New Issue
2014-12-03 06:03 davidl Status new => assigned
2014-12-03 06:03 davidl Assigned To => davidl
2014-12-03 15:44 davidl Note Added: 0000619
2015-06-10 09:42 davidl Note Added: 0000647
2015-06-10 09:42 davidl Status assigned => resolved
2015-06-10 09:42 davidl Resolution open => fixed


Copyright © 2000 - 2020 MantisBT Team
Powered by Mantis Bugtracker